unit UfcTrip;

interface

uses
  Windows, Messages, SysUtils, Classes;

type
  TUfcTripper = class(TComponent)
  private
    FKey: string;
    FTrip: string;
    procedure SetKey(const Value: string);
    { Private 錾 }
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    property Trip: string read FTrip;
  published
    { Published 錾 }
    property Key: string read FKey write SetKey;
  end;

procedure Register;

function _crypt(Key: PChar; Salt: PChar): PChar; cdecl;

implementation

{$L crypt.obj}
{$L crypt_util.obj}

function _crypt; external;

procedure _bzero(P: Pointer; Count: Integer); cdecl;
begin
	FillChar(P^, Count, 0);
end;

procedure _bcopy(P1: Pointer; P2: Pointer; Count: Integer); cdecl;
begin
	Move(P1^, P2^, Count);
end;

procedure Register;
begin
  RegisterComponents('Samples', [TUfcTripper]);
end;

{ TUfcCrypt }

procedure TUfcTripper.SetKey(const Value: string);
var
	Trip, Salt: string;

begin
	if FKey <> Value then
  begin
  	FKey := Copy(Value, 1, 10);
    if Length(FKey) >= 2 then
    	Salt := Copy(FKey, 2, 2);
    Trip := _crypt(PChar(FKey), PChar(Salt));
    FTrip := Copy(Trip, Length(Trip) - 10 + 1, MaxInt);
  end;
end;

end.






